<template>
  <div>
    <div class="mt-8 mx-auto max-w-lg">
        <h3 class="text-gray-700 text-2xl font-small">Pokemon Record</h3>
      <div class="mt-4">
        <div class="p-6 bg-white rounded-md shadow-md">
          <h2 class="text-lg text-gray-700 font-semibold capitalize">
            {{pokemonRecord.name}}
          </h2>
            <div class="flex-shrink-0 w-20 h-20">
                <img class="w-full h-full rounded-full" :src=pokemonRecord.sprite_url alt/>
            </div>
          <FormulateForm
            @submit="submitHandler"
          >
              <div class="grid grid-cols-1 sm:grid-cols-1 gap-4 mt-4">
                <FormulateInput
                  type="text"
                  input-class="form-input w-full mt-2 rounded-md focus:border-indigo-600"
                  v-model="pokemonRecord.name"
                  label="Name"
                />
                <FormulateInput
                  type="text"
                  v-model="pokemonRecord.base_experience"
                  label="Base Experience"
                /> 
                <FormulateInput
                  type="text"
                  v-model="pokemonRecord.height"
                  label="Height"
                />
              </div>
            <div class="grid grid-cols-3 sm:grid-cols-3 gap-2 mt-4">
              <FormulateInput
                type="submit"
                label="Update"
              />

              <FormulateInput
                name="delete"
                type="button"
                label="delete"
                @click="deletePokemon"
              />

              <FormulateInput
                name="back"
                type="button"
                label="back"
                @click="goHome"
              />
            </div>
          </FormulateForm>
        </div>  
      </div>
    </div>
  </div>
</template>
<script>
  import axios from 'axios';
  export default {
    name: 'Pokemon',
    data: function() {
        return {
            pokemonRecord: {}
        }
    },
    created: function () {
      this.fetchPokemon('/api/pokemon/' + this.$route.params.id)
    },
    methods: {
      fetchPokemon: function (page_url) {
        var vm = this;
        axios
          .get(page_url)
          .then(function (response) {
              vm.pokemonRecord = response.data;
          });
      },
      updatePokemon: function (data) {
        var vm = this;
        axios
          .patch('/api/pokemon/' + this.$route.params.id, 
          data
        )
        .then(function (response) {
          vm.fetchPokemon('/api/pokemon/' + vm.$route.params.id);
        })
      },
      deletePokemon: function (data) {
        var vm = this;
        axios
          .delete('/api/pokemon/' + this.$route.params.id
        )
        .then(function (response) {
            vm.$router.push('/');
        })
      },
      goHome: function (data) {
        this.$router.push('/');
      },
      submitHandler (data) {
        this.updatePokemon(this.pokemonRecord);
    }
    },
  }
</script>